# -*- coding: utf-8 -*-

# ------------------------------------------------------------
# directly start the browsing
# 
# Autor: Oliver Maurhart, <oliver.maurhart@ait.ac.at>
#
# Copyright (C) 2013 AIT Austrian Institute of Technology
# AIT Austrian Institute of Technology GmbH
# Donau-City-Strasse 1 | 1220 Vienna | Austria
# http://www.ait.ac.at
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation version 2.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, 
# Boston, MA  02110-1301, USA.
# ------------------------------------------------------------


# ------------------------------------------------------------
# imports

import sys
import urllib
import urllib2

from PyQt4 import QtCore
from PyQt4 import QtGui

# local
import __init__ as opensecurity
import proxy_getter

if sys.platform == 'win32' or sys.platform == 'cygwin':
    from cygwin import Cygwin


# ------------------------------------------------------------
# code


# start
if __name__ == "__main__":

    if not (sys.platform == 'win32' or sys.platform == 'cygwin'):
        QtGui.QMessageBox.critical(None, 'OpenSecurity Error', 'This action is not supported on this platform.\nSorry.')
        sys.exit(1)
   
    try:
    
        # get a proper browsing VM
        Cygwin.start_X11()
        
        proxy_support = urllib2.ProxyHandler({})
        opener = urllib2.build_opener(proxy_support)
        urllib2.install_opener(opener)

        req_data = ""
        proxy = proxy_getter.getProxySettings()
        if proxy:
            req_data = '?' + urllib.urlencode(proxy) 
        req = 'http://127.0.0.1:8080/browsing'+ req_data
        browsing_vm = urllib2.urlopen(req).readline()
        print('Called '+ req + ' got: ' + str(browsing_vm))
        
    except:
        
        QtGui.QApplication.instance().processEvents()
        QtGui.QMessageBox.critical(None, 'Failed to invoke Safe Internet Browsing', 'OpenSecurity Error')

